diff --git a/sys/dev/netif/ath/ath/if_ath.c b/sys/dev/netif/ath/ath/if_ath.c
index 279f7ce..2e0d0e5 100644
--- a/sys/dev/netif/ath/ath/if_ath.c
+++ b/sys/dev/netif/ath/ath/if_ath.c
@@ -288,164 +288,6 @@ ath_legacy_attach_comp_func(struct ath_softc *sc)
 	}
 }
 
-/*
- * Set the target power mode.
- *
- * If this is called during a point in time where
- * the hardware is being programmed elsewhere, it will
- * simply store it away and update it when all current
- * uses of the hardware are completed.
- */
-void
-_ath_power_setpower(struct ath_softc *sc, int power_state, const char *file, int line)
-{
-	ATH_LOCK_ASSERT(sc);
-
-	sc->sc_target_powerstate = power_state;
-
-	DPRINTF(sc, ATH_DEBUG_PWRSAVE, "%s: (%s:%d) state=%d, refcnt=%d\n",
-	    __func__,
-	    file,
-	    line,
-	    power_state,
-	    sc->sc_powersave_refcnt);
-
-	if (sc->sc_powersave_refcnt == 0 &&
-	    power_state != sc->sc_cur_powerstate) {
-		sc->sc_cur_powerstate = power_state;
-		ath_hal_setpower(sc->sc_ah, power_state);
-
-		/*
-		 * If the NIC is force-awake, then set the
-		 * self-gen frame state appropriately.
-		 *
-		 * If the nic is in network sleep or full-sleep,
-		 * we let the above call leave the self-gen
-		 * state as "sleep".
-		 */
-		if (sc->sc_cur_powerstate == HAL_PM_AWAKE &&
-		    sc->sc_target_selfgen_state != HAL_PM_AWAKE) {
-			ath_hal_setselfgenpower(sc->sc_ah,
-			    sc->sc_target_selfgen_state);
-		}
-	}
-}
-
-/*
- * Set the current self-generated frames state.
- *
- * This is separate from the target power mode.  The chip may be
- * awake but the desired state is "sleep", so frames sent to the
- * destination has PWRMGT=1 in the 802.11 header.  The NIC also
- * needs to know to set PWRMGT=1 in self-generated frames.
- */
-void
-_ath_power_set_selfgen(struct ath_softc *sc, int power_state, const char *file, int line)
-{
-
-	ATH_LOCK_ASSERT(sc);
-
-	DPRINTF(sc, ATH_DEBUG_PWRSAVE, "%s: (%s:%d) state=%d, refcnt=%d\n",
-	    __func__,
-	    file,
-	    line,
-	    power_state,
-	    sc->sc_target_selfgen_state);
-
-	sc->sc_target_selfgen_state = power_state;
-
-	/*
-	 * If the NIC is force-awake, then set the power state.
-	 * Network-state and full-sleep will already transition it to
-	 * mark self-gen frames as sleeping - and we can't
-	 * guarantee the NIC is awake to program the self-gen frame
-	 * setting anyway.
-	 */
-	if (sc->sc_cur_powerstate == HAL_PM_AWAKE) {
-		ath_hal_setselfgenpower(sc->sc_ah, power_state);
-	}
-}
-
-/*
- * Set the hardware power mode and take a reference.
- *
- * This doesn't update the target power mode in the driver;
- * it just updates the hardware power state.
- *
- * XXX it should only ever force the hardware awake; it should
- * never be called to set it asleep.
- */
-void
-_ath_power_set_power_state(struct ath_softc *sc, int power_state, const char *file, int line)
-{
-	ATH_LOCK_ASSERT(sc);
-
-	DPRINTF(sc, ATH_DEBUG_PWRSAVE, "%s: (%s:%d) state=%d, refcnt=%d\n",
-	    __func__,
-	    file,
-	    line,
-	    power_state,
-	    sc->sc_powersave_refcnt);
-
-	sc->sc_powersave_refcnt++;
-
-	if (power_state != sc->sc_cur_powerstate) {
-		ath_hal_setpower(sc->sc_ah, power_state);
-		sc->sc_cur_powerstate = power_state;
-
-		/*
-		 * Adjust the self-gen powerstate if appropriate.
-		 */
-		if (sc->sc_cur_powerstate == HAL_PM_AWAKE &&
-		    sc->sc_target_selfgen_state != HAL_PM_AWAKE) {
-			ath_hal_setselfgenpower(sc->sc_ah,
-			    sc->sc_target_selfgen_state);
-		}
-
-	}
-}
-
-/*
- * Restore the power save mode to what it once was.
- *
- * This will decrement the reference counter and once it hits
- * zero, it'll restore the powersave state.
- */
-void
-_ath_power_restore_power_state(struct ath_softc *sc, const char *file, int line)
-{
-
-	ATH_LOCK_ASSERT(sc);
-
-	DPRINTF(sc, ATH_DEBUG_PWRSAVE, "%s: (%s:%d) refcnt=%d, target state=%d\n",
-	    __func__,
-	    file,
-	    line,
-	    sc->sc_powersave_refcnt,
-	    sc->sc_target_powerstate);
-
-	if (sc->sc_powersave_refcnt == 0)
-		device_printf(sc->sc_dev, "%s: refcnt=0?\n", __func__);
-	else
-		sc->sc_powersave_refcnt--;
-
-	if (sc->sc_powersave_refcnt == 0 &&
-	    sc->sc_target_powerstate != sc->sc_cur_powerstate) {
-		sc->sc_cur_powerstate = sc->sc_target_powerstate;
-		ath_hal_setpower(sc->sc_ah, sc->sc_target_powerstate);
-	}
-
-	/*
-	 * Adjust the self-gen powerstate if appropriate.
-	 */
-	if (sc->sc_cur_powerstate == HAL_PM_AWAKE &&
-	    sc->sc_target_selfgen_state != HAL_PM_AWAKE) {
-		ath_hal_setselfgenpower(sc->sc_ah,
-		    sc->sc_target_selfgen_state);
-	}
-
-}
-
 #define	HAL_MODE_HT20 (HAL_MODE_11NG_HT20 | HAL_MODE_11NA_HT20)
 #define	HAL_MODE_HT40 \
 	(HAL_MODE_11NG_HT40PLUS | HAL_MODE_11NG_HT40MINUS | \
@@ -517,10 +359,6 @@ ath_attach(u_int16_t devid, struct ath_softc *sc)
 		ath_xmit_setup_legacy(sc);
 	}
 
-	if (ath_hal_hasmybeacon(sc->sc_ah)) {
-		sc->sc_do_mybeacon = 1;
-	}
-
 	/*
 	 * Check if the MAC has multi-rate retry support.
 	 * We do this by trying to setup a fake extended
@@ -793,8 +631,6 @@ ath_attach(u_int16_t devid, struct ath_softc *sc)
 #ifdef	ATH_ENABLE_DFS
 		| IEEE80211_C_DFS		/* Enable radar detection */
 #endif
-		| IEEE80211_C_PMGT		/* Station side power mgmt */
-		| IEEE80211_C_SWSLEEP
 		;
 	/*
 	 * Query the hal to figure out h/w crypto support.
@@ -1183,12 +1019,6 @@ ath_attach(u_int16_t devid, struct ath_softc *sc)
 	if (bootverbose)
 		ieee80211_announce(ic);
 	ath_announce(sc);
-
-	/*
-	 * Put it to sleep for now.
-	 */
-	ath_power_setpower(sc, HAL_PM_FULL_SLEEP);
-
 	return 0;
 bad2:
 	ath_tx_cleanup(sc);
@@ -1237,18 +1067,6 @@ ath_detach(struct ath_softc *sc)
 	 *   it last
 	 * Other than that, it's straightforward...
 	 */
-
-	/*
-	 * XXX Wake the hardware up first.  ath_stop() will still
-	 * wake it up first, but I'd rather do it here just to
-	 * ensure it's awake.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-	ath_power_setpower(sc, HAL_PM_AWAKE);
-
-	/*
-	 * Stop things cleanly.
-	 */
 	ath_stop(ifp);
 	wlan_serialize_enter();
 	ieee80211_ifdetach(ifp->if_l2com);
@@ -1623,8 +1441,6 @@ ath_vap_delete(struct ieee80211vap *vap)
 	struct ath_hal *ah = sc->sc_ah;
 	struct ath_vap *avp = ATH_VAP(vap);
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	DPRINTF(sc, ATH_DEBUG_RESET, "%s: called\n", __func__);
 	if (ifp->if_flags & IFF_RUNNING) {
 		/*
@@ -1638,8 +1454,6 @@ ath_vap_delete(struct ieee80211vap *vap)
 		ath_stoprecv(sc, 1);		/* stop recv side */
 	}
 
-	/* .. leave the hardware awake for now. */
-
 	ieee80211_vap_detach(vap);
 
 	/*
@@ -1727,9 +1541,6 @@ ath_vap_delete(struct ieee80211vap *vap)
 		}
 		ath_hal_intrset(ah, sc->sc_imask);
 	}
-
-	/* Ok, let the hardware asleep. */
-	ath_power_restore_power_state(sc);
 	ATH_UNLOCK(sc);
 }
 
@@ -1775,10 +1586,8 @@ ath_reset_keycache(struct ath_softc *sc)
 	struct ath_hal *ah = sc->sc_ah;
 	int i;
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
 	for (i = 0; i < sc->sc_keymax; i++)
 		ath_hal_keyreset(ah, i);
-	ath_power_restore_power_state(sc);
 	ieee80211_crypto_reload_keys(ic);
 }
 
@@ -1830,12 +1639,6 @@ ath_resume(struct ath_softc *sc)
 	    sc->sc_curchan != NULL ? sc->sc_curchan : ic->ic_curchan);
 	ath_hal_setchainmasks(sc->sc_ah, sc->sc_cur_txchainmask,
 	    sc->sc_cur_rxchainmask);
-
-	/* Ensure we set the current power state to on */
-	ath_power_setselfgen(sc, HAL_PM_AWAKE);
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-	ath_power_setpower(sc, HAL_PM_AWAKE);
-
 	ath_hal_reset(ah, sc->sc_opmode,
 	    sc->sc_curchan != NULL ? sc->sc_curchan : ic->ic_curchan,
 	    AH_FALSE, &status);
@@ -1868,8 +1671,6 @@ ath_resume(struct ath_softc *sc)
 	if (sc->sc_resume_up)
 		ieee80211_resume_all(ic);
 
-	ath_power_restore_power_state(sc);
-
 	/* XXX beacons ? */
 }
 
@@ -1927,8 +1728,6 @@ ath_intr(void *arg)
 		return;
 	}
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	if ((ifp->if_flags & IFF_UP) == 0 ||
 	    (ifp->if_flags & IFF_RUNNING) == 0) {
 		HAL_INT status;
@@ -1938,7 +1737,6 @@ ath_intr(void *arg)
 		ath_hal_getisr(ah, &status);	/* clear ISR */
 		ath_hal_intrset(ah, 0);		/* disable further intr's */
 		ATH_PCU_UNLOCK(sc);
-		ath_power_restore_power_state(sc);
 		return;
 	}
 
@@ -1978,7 +1776,6 @@ ath_intr(void *arg)
 	/* Short-circuit un-handled interrupts */
 	if (status == 0x0) {
 		ATH_PCU_UNLOCK(sc);
-		ath_power_restore_power_state(sc);
 		return;
 	}
 
@@ -2145,16 +1942,10 @@ ath_intr(void *arg)
 			ATH_KTR(sc, ATH_KTR_ERROR, 0, "ath_intr: RXORN");
 			sc->sc_stats.ast_rxorn++;
 		}
-		if (status & HAL_INT_TSFOOR) {
-			device_printf(sc->sc_dev, "%s: TSFOOR\n", __func__);
-			sc->sc_syncbeacon = 1;
-		}
 	}
 	ATH_PCU_LOCK(sc);
 	sc->sc_intr_cnt--;
 	ATH_PCU_UNLOCK(sc);
-
-	ath_power_restore_power_state(sc);
 }
 
 static void
@@ -2187,8 +1978,6 @@ ath_fatal_proc(void *arg, int pending)
 static void
 ath_bmiss_vap(struct ieee80211vap *vap)
 {
-	struct ath_softc *sc = vap->iv_ic->ic_ifp->if_softc;
-
 	/*
 	 * Workaround phantom bmiss interrupts by sanity-checking
 	 * the time of our last rx'd frame.  If it is within the
@@ -2197,15 +1986,9 @@ ath_bmiss_vap(struct ieee80211vap *vap)
 	 * be dispatched up for processing.  Note this applies only
 	 * for h/w beacon miss events.
 	 */
-
-	/*
-	 * XXX TODO: Just read the TSF during the interrupt path;
-	 * that way we don't have to wake up again just to read it
-	 * again.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	if ((vap->iv_flags_ext & IEEE80211_FEXT_SWBMISS) == 0) {
+		struct ifnet *ifp = vap->iv_ic->ic_ifp;
+		struct ath_softc *sc = ifp->if_softc;
 		u_int64_t lastrx = sc->sc_lastrx;
 		u_int64_t tsf = ath_hal_gettsf64(sc->sc_ah);
 		/* XXX should take a locked ref to iv_bss */
@@ -2220,26 +2003,12 @@ ath_bmiss_vap(struct ieee80211vap *vap)
 
 		if (tsf - lastrx <= bmisstimeout) {
 			sc->sc_stats.ast_bmiss_phantom++;
-			ath_power_restore_power_state(sc);
 			return;
 		}
 	}
-
-	/*
-	 * There's no need to keep the hardware awake during the call
-	 * to av_bmiss().
-	 */
-	ath_power_restore_power_state(sc);
-
-	/*
-	 * Attempt to force a beacon resync.
-	 */
-	sc->sc_syncbeacon = 1;
-
 	ATH_VAP(vap)->av_bmiss(vap);
 }
 
-/* XXX this needs a force wakeup! */
 int
 ath_hal_gethangstate(struct ath_hal *ah, uint32_t mask, uint32_t *hangs)
 {
@@ -2269,8 +2038,6 @@ ath_bmiss_proc(void *arg, int pending)
 	 * to clear.
 	 */
 	wlan_serialize_enter();
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-	ath_beacon_miss(sc);
 	if (ath_hal_gethangstate(sc->sc_ah, 0xff, &hangs) && hangs != 0) {
 		ath_reset(ifp, ATH_RESET_NOLOSS);
 		if_printf(ifp, "bb hang detected (0x%x), resetting\n", hangs);
@@ -2278,11 +2045,6 @@ ath_bmiss_proc(void *arg, int pending)
 		ath_reset(ifp, ATH_RESET_NOLOSS);
 		ieee80211_beacon_miss(ifp->if_l2com);
 	}
-
-	/* Force a beacon resync, in case they've drifted */
-	sc->sc_syncbeacon = 1;
-	ath_power_restore_power_state(sc);
-
 	wlan_serialize_exit();
 }
 
@@ -2394,7 +2156,6 @@ ath_init(void *arg)
 	 */
 	if (ath_startrecv(sc) != 0) {
 		if_printf(ifp, "unable to start recv logic\n");
-		ath_power_restore_power_state(sc);
 		ATH_UNLOCK(sc);
 		return;
 	}
@@ -2421,15 +2182,6 @@ ath_init(void *arg)
 	if (sc->sc_needmib && ic->ic_opmode == IEEE80211_M_STA)
 		sc->sc_imask |= HAL_INT_MIB;
 
-	/*
-	 * XXX add capability for this.
-	 *
-	 * If we're in STA mode (and maybe IBSS?) then register for
-	 * TSFOOR interrupts.
-	 */
-	if (ic->ic_opmode == IEEE80211_M_STA)
-		sc->sc_imask |= HAL_INT_TSFOOR;
-
 	/* Enable global TX timeout and carrier sense timeout if available */
 	if (ath_hal_gtxto_supported(ah))
 		sc->sc_imask |= HAL_INT_GTT;
@@ -2441,7 +2193,6 @@ ath_init(void *arg)
 	callout_reset(&sc->sc_wd_ch, hz, ath_watchdog, sc);
 	ath_hal_intrset(ah, sc->sc_imask);
 
-	ath_power_restore_power_state(sc);
 	ATH_UNLOCK(sc);
 
 #ifdef ATH_TX99_DIAG
@@ -2462,12 +2213,6 @@ ath_stop_locked(struct ifnet *ifp)
 		__func__, sc->sc_invalid, ifp->if_flags);
 
 	ATH_LOCK_ASSERT(sc);
-
-	/*
-	 * Wake the hardware up before fiddling with it.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	if (ifp->if_flags & IFF_RUNNING) {
 		/*
 		 * Shutdown the hardware and driver:
@@ -2508,20 +2253,9 @@ ath_stop_locked(struct ifnet *ifp)
 			sc->sc_rxlink = NULL;
 		ath_beacon_free(sc);	/* XXX not needed */
 	}
-
-	/* And now, restore the current power state */
-	ath_power_restore_power_state(sc);
 }
 
-/*
- * Wait until all pending TX/RX has completed.
- *
- * This waits until all existing transmit, receive and interrupts
- * have completed.  It's assumed that the caller has first
- * grabbed the reset lock so it doesn't try to do overlapping
- * chip resets.
- */
-#define	MAX_TXRX_ITERATIONS	100
+#define	MAX_TXRX_ITERATIONS	1000
 static void
 ath_txrx_stop_locked(struct ath_softc *sc)
 {
@@ -2540,7 +2274,7 @@ ath_txrx_stop_locked(struct ath_softc *sc)
 	    sc->sc_txstart_cnt || sc->sc_intr_cnt) {
 		if (i <= 0)
 			break;
-		wlan_serialize_sleep(sc, 0, "ath_txrx_stop", (hz + 99) / 100);
+		wlan_serialize_sleep(sc, 0, "ath_txrx_stop", 1);
 		i--;
 	}
 
@@ -2587,7 +2321,7 @@ ath_txrx_start(struct ath_softc *sc)
  * Another, cleaner way should be found to serialise all of
  * these operations.
  */
-#define	MAX_RESET_ITERATIONS	25
+#define	MAX_RESET_ITERATIONS	10
 static int
 ath_reset_grablock(struct ath_softc *sc, int dowait)
 {
@@ -2605,8 +2339,7 @@ ath_reset_grablock(struct ath_softc *sc, int dowait)
 			break;
 		}
 		ATH_PCU_UNLOCK(sc);
-		wlan_serialize_sleep(sc, 0, "ath_reset_grablock",
-				     (hz + 9) / 10);
+		wlan_serialize_sleep(sc, 0, "ath_reset_grablock", 1);
 		i--;
 		ATH_PCU_LOCK(sc);
 	} while (i > 0);
@@ -2671,11 +2404,6 @@ ath_reset(struct ifnet *ifp, ATH_RESET_TYPE reset_type)
 	/* Try to (stop any further TX/RX from occuring */
 	taskqueue_block(sc->sc_tq);
 
-	/*
-	 * Wake the hardware up.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_PCU_LOCK(sc);
 
 	/*
@@ -2770,13 +2498,9 @@ ath_reset(struct ifnet *ifp, ATH_RESET_TYPE reset_type)
 	 * reset counter - this way ath_intr() doesn't end up
 	 * disabling interrupts without a corresponding enable
 	 * in the rest or channel change path.
-	 *
-	 * Grab the TX reference in case we need to transmit.
-	 * That way a parallel transmit doesn't.
 	 */
 	ATH_PCU_LOCK(sc);
 	sc->sc_inreset_cnt--;
-	sc->sc_txstart_cnt++;
 	/* XXX only do this if sc_inreset_cnt == 0? */
 	ath_hal_intrset(ah, sc->sc_imask);
 	ATH_PCU_UNLOCK(sc);
@@ -2790,8 +2514,6 @@ ath_reset(struct ifnet *ifp, ATH_RESET_TYPE reset_type)
 	 * run.
 	 */
 
-	/* XXX TODO: we need to hold the tx refcount here! */
-
 	/* Restart TX/RX as needed */
 	ath_txrx_start(sc);
 
@@ -2822,12 +2544,6 @@ ath_reset(struct ifnet *ifp, ATH_RESET_TYPE reset_type)
 	IF_UNLOCK(&ifp->if_snd);
 #endif
 
-	ath_power_restore_power_state(sc);
-
-	ATH_PCU_LOCK(sc);
-	sc->sc_txstart_cnt--;
-	ATH_PCU_UNLOCK(sc);
-
 	/* Handle any frames in the TX queue */
 	/*
 	 * XXX should this be done by the caller, rather than
@@ -2968,7 +2684,6 @@ ath_buf_clone(struct ath_softc *sc, struct ath_buf *bf)
 	tbf->bf_status = bf->bf_status;
 	tbf->bf_m = bf->bf_m;
 	tbf->bf_node = bf->bf_node;
-	KASSERT((bf->bf_node != NULL), ("%s: bf_node=NULL!", __func__));
 	/* will be setup by the chain/setup function */
 	tbf->bf_lastds = NULL;
 	/* for now, last == self */
@@ -3084,9 +2799,6 @@ ath_transmit(struct ifnet *ifp, struct mbuf *m)
 	sc->sc_txstart_cnt++;
 	ATH_PCU_UNLOCK(sc);
 
-	/* Wake the hardware up already */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_KTR(sc, ATH_KTR_TX, 0, "ath_transmit: start");
 	/*
 	 * Grab the TX lock - it's ok to do this here; we haven't
@@ -3323,9 +3035,6 @@ finish:
 	sc->sc_txstart_cnt--;
 	ATH_PCU_UNLOCK(sc);
 
-	/* Sleep the hardware if required */
-	ath_power_restore_power_state(sc);
-
 	ATH_KTR(sc, ATH_KTR_TX, 0, "ath_transmit: finished");
 	
 	return (retval);
@@ -3353,6 +3062,7 @@ ath_key_update_begin(struct ieee80211vap *vap)
 
 	DPRINTF(sc, ATH_DEBUG_KEYCACHE, "%s:\n", __func__);
 	taskqueue_block(sc->sc_tq);
+	IF_LOCK(&ifp->if_snd);		/* NB: doesn't block mgmt frames */
 }
 
 static void
@@ -3362,6 +3072,7 @@ ath_key_update_end(struct ieee80211vap *vap)
 	struct ath_softc *sc = ifp->if_softc;
 
 	DPRINTF(sc, ATH_DEBUG_KEYCACHE, "%s:\n", __func__);
+	IF_UNLOCK(&ifp->if_snd);
 	taskqueue_unblock(sc->sc_tq);
 }
 
@@ -3372,10 +3083,8 @@ ath_update_promisc(struct ifnet *ifp)
 	u_int32_t rfilt;
 
 	/* configure rx filter */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
 	rfilt = ath_calcrxfilter(sc);
 	ath_hal_setrxfilter(sc->sc_ah, rfilt);
-	ath_power_restore_power_state(sc);
 
 	DPRINTF(sc, ATH_DEBUG_MODE, "%s: RX filter 0x%x\n", __func__, rfilt);
 }
@@ -3415,9 +3124,7 @@ ath_update_mcast(struct ifnet *ifp)
 #endif
 	} else
 		mfilt[0] = mfilt[1] = ~0;
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
 	ath_hal_setmcastfilter(sc->sc_ah, mfilt[0], mfilt[1]);
-	ath_power_restore_power_state(sc);
 	DPRINTF(sc, ATH_DEBUG_MODE, "%s: MC filter %08x:%08x\n",
 		__func__, mfilt[0], mfilt[1]);
 }
@@ -3481,10 +3188,7 @@ ath_setslottime(struct ath_softc *sc)
 	    __func__, ic->ic_curchan->ic_freq, ic->ic_curchan->ic_flags,
 	    ic->ic_flags & IEEE80211_F_SHSLOT ? "short" : "long", usec);
 
-	/* Wake up the hardware first before updating the slot time */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
 	ath_hal_setslottime(ah, usec);
-	ath_power_restore_power_state(sc);
 	sc->sc_updateslot = OK;
 }
 
@@ -3502,8 +3206,6 @@ ath_updateslot(struct ifnet *ifp)
 	 * When not coordinating the BSS, change the hardware
 	 * immediately.  For other operation we defer the change
 	 * until beacon updates have propagated to the stations.
-	 *
-	 * XXX sc_updateslot isn't changed behind a lock?
 	 */
 	if (ic->ic_opmode == IEEE80211_M_HOSTAP ||
 	    ic->ic_opmode == IEEE80211_M_MBSS)
@@ -4635,8 +4337,6 @@ ath_tx_proc_q0(void *arg, int npending)
 	sc->sc_txq_active &= ~txqs;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_KTR(sc, ATH_KTR_TXCOMP, 1,
 	    "ath_tx_proc_q0: txqs=0x%08x", txqs);
 
@@ -4660,8 +4360,6 @@ ath_tx_proc_q0(void *arg, int npending)
 	sc->sc_txproc_cnt--;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_restore_power_state(sc);
-
 	ath_tx_kick(sc);
 	wlan_serialize_exit();
 }
@@ -4687,8 +4385,6 @@ ath_tx_proc_q0123(void *arg, int npending)
 	sc->sc_txq_active &= ~txqs;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_KTR(sc, ATH_KTR_TXCOMP, 1,
 	    "ath_tx_proc_q0123: txqs=0x%08x", txqs);
 
@@ -4724,8 +4420,6 @@ ath_tx_proc_q0123(void *arg, int npending)
 	sc->sc_txproc_cnt--;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_restore_power_state(sc);
-
 	ath_tx_kick(sc);
 	wlan_serialize_exit();
 }
@@ -4750,8 +4444,6 @@ ath_tx_proc(void *arg, int npending)
 	sc->sc_txq_active &= ~txqs;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_KTR(sc, ATH_KTR_TXCOMP, 1, "ath_tx_proc: txqs=0x%08x", txqs);
 
 	/*
@@ -4780,8 +4472,6 @@ ath_tx_proc(void *arg, int npending)
 	sc->sc_txproc_cnt--;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_restore_power_state(sc);
-
 	ath_tx_kick(sc);
 	wlan_serialize_exit();
 }
@@ -4812,8 +4502,6 @@ ath_txq_sched_tasklet(void *arg, int npending)
 	sc->sc_txproc_cnt++;
 	ATH_PCU_UNLOCK(sc);
 
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_TX_LOCK(sc);
 	for (i = 0; i < HAL_NUM_TX_QUEUES; i++) {
 		if (ATH_TXQ_SETUP(sc, i)) {
@@ -4822,8 +4510,6 @@ ath_txq_sched_tasklet(void *arg, int npending)
 	}
 	ATH_TX_UNLOCK(sc);
 
-	ath_power_restore_power_state(sc);
-
 	ATH_PCU_LOCK(sc);
 	sc->sc_txproc_cnt--;
 	ATH_PCU_UNLOCK(sc);
@@ -5480,15 +5166,6 @@ ath_calibrate(void *arg)
 	HAL_BOOL aniCal, shortCal = AH_FALSE;
 	int nextcal;
 
-	/*
-	 * Force the hardware awake for ANI work.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
-	/* Skip trying to do this if we're in reset */
-	if (sc->sc_inreset_cnt)
-		goto restart;
-
 	wlan_serialize_enter();
 	if (ic->ic_flags & IEEE80211_F_SCAN)	/* defer, off channel */
 		goto restart;
@@ -5591,10 +5268,6 @@ restart:
 		/* NB: don't rearm timer */
 	}
 done:
-	/*
-	 * Restore power state now that we're done.
-	 */
-	ath_power_restore_power_state(sc);
 	wlan_serialize_exit();
 }
 
@@ -5689,10 +5362,8 @@ ath_set_channel(struct ieee80211com *ic)
 	 * sta/ibss mode this has no effect in other operating modes.
 	 */
 	ATH_LOCK(sc);
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
 	if (!sc->sc_scanning && ic->ic_curchan == ic->ic_bsschan)
 		sc->sc_syncbeacon = 1;
-	ath_power_restore_power_state(sc);
 	ATH_UNLOCK(sc);
 }
 
@@ -5725,7 +5396,6 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 	int i, error, stamode;
 	u_int32_t rfilt;
 	int csa_run_transition = 0;
-	enum ieee80211_state ostate = vap->iv_state;
 
 	static const HAL_LED_STATE leds[] = {
 	    HAL_LED_INIT,	/* IEEE80211_S_INIT */
@@ -5739,7 +5409,7 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 	};
 
 	DPRINTF(sc, ATH_DEBUG_STATE, "%s: %s -> %s\n", __func__,
-		ieee80211_state_name[ostate],
+		ieee80211_state_name[vap->iv_state],
 		ieee80211_state_name[nstate]);
 
 	/*
@@ -5751,24 +5421,7 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 	 */
 	IEEE80211_LOCK_ASSERT(ic);
 
-	/* Before we touch the hardware - wake it up */
-	/*
-	 * If the NIC is in anything other than SLEEP state,
-	 * we need to ensure that self-generated frames are
-	 * set for PWRMGT=0.  Otherwise we may end up with
-	 * strange situations.
-	 *
-	 * XXX TODO: is this actually the case? :-)
-	 */
-	if (nstate != IEEE80211_S_SLEEP)
-		ath_power_setselfgen(sc, HAL_PM_AWAKE);
-
-	/*
-	 * Now, wake the thing up.
-	 */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
-	if (ostate == IEEE80211_S_CSA && nstate == IEEE80211_S_RUN)
+	if (vap->iv_state == IEEE80211_S_CSA && nstate == IEEE80211_S_RUN)
 		csa_run_transition = 1;
 
 	wlan_serialize_exit();
@@ -5783,11 +5436,6 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 		 * [re]setup beacons.  Unblock the task q thread so
 		 * deferred interrupt processing is done.
 		 */
-
-		/* Ensure we stay awake during scan */
-		ath_power_setselfgen(sc, HAL_PM_AWAKE);
-		ath_power_setpower(sc, HAL_PM_AWAKE);
-
 		ath_hal_intrset(ah,
 		    sc->sc_imask &~ (HAL_INT_SWBA | HAL_INT_BMISS));
 		sc->sc_imask &= ~(HAL_INT_SWBA | HAL_INT_BMISS);
@@ -5800,11 +5448,6 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 	stamode = (vap->iv_opmode == IEEE80211_M_STA ||
 		   vap->iv_opmode == IEEE80211_M_AHDEMO ||
 		   vap->iv_opmode == IEEE80211_M_IBSS);
-
-	/*
-	 * XXX Dont need to do this (and others) if we've transitioned
-	 * from SLEEP->RUN.
-	 */
 	if (stamode && nstate == IEEE80211_S_RUN) {
 		sc->sc_curaid = ni->ni_associd;
 		IEEE80211_ADDR_COPY(sc->sc_curbssid, ni->ni_bssid);
@@ -5909,30 +5552,25 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 			 * beacon to update the beacon timer and thus we
 			 * won't get notified of the missing beacons.
 			 */
-			if (ostate != IEEE80211_S_RUN &&
-			    ostate != IEEE80211_S_SLEEP) {
-				DPRINTF(sc, ATH_DEBUG_BEACON,
-					"%s: STA; syncbeacon=1\n", __func__);
-				sc->sc_syncbeacon = 1;
-
-				if (csa_run_transition)
-					ath_beacon_config(sc, vap);
+			sc->sc_syncbeacon = 1;
+#if 0
+			if (csa_run_transition)
+#endif
+				ath_beacon_config(sc, vap);
 
-				/*
-				 * PR: kern/175227
-				 *
-				 * Reconfigure beacons during reset; as
-				 * otherwise
-				 * we won't get the beacon timers reprogrammed
-				 * after a reset and thus we won't pick up a
-				 * beacon miss interrupt.
-				 *
-				 * Hopefully we'll see a beacon before the BMISS
-				 * timer fires (too often), leading to a STA
-				 * disassociation.
-				 */
-				sc->sc_beacons = 1;
-			}
+			/*
+			 * PR: kern/175227
+			 *
+			 * Reconfigure beacons during reset; as otherwise
+			 * we won't get the beacon timers reprogrammed
+			 * after a reset and thus we won't pick up a
+			 * beacon miss interrupt.
+			 *
+			 * Hopefully we'll see a beacon before the BMISS
+			 * timer fires (too often), leading to a STA
+			 * disassociation.
+			 */
+			sc->sc_beacons = 1;
 			break;
 		case IEEE80211_M_MONITOR:
 			/*
@@ -5958,13 +5596,6 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 		sc->sc_halstats.ns_avgbrssi = ATH_RSSI_DUMMY_MARKER;
 		sc->sc_halstats.ns_avgrssi = ATH_RSSI_DUMMY_MARKER;
 		sc->sc_halstats.ns_avgtxrssi = ATH_RSSI_DUMMY_MARKER;
-
-		/*
-		 * Force awake for RUN mode
-		 */
-		ath_power_setselfgen(sc, HAL_PM_AWAKE);
-		ath_power_setpower(sc, HAL_PM_AWAKE);
-
 		/*
 		 * Finally, start any timers and the task q thread
 		 * (in case we didn't go through SCAN state).
@@ -5976,7 +5607,6 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 			DPRINTF(sc, ATH_DEBUG_CALIBRATE,
 			    "%s: calibration disabled\n", __func__);
 		}
-
 		taskqueue_unblock(sc->sc_tq);
 	} else if (nstate == IEEE80211_S_INIT) {
 		/*
@@ -5996,42 +5626,9 @@ ath_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 #ifdef IEEE80211_SUPPORT_TDMA
 		ath_hal_setcca(ah, AH_TRUE);
 #endif
-	} else if (nstate == IEEE80211_S_SLEEP) {
-		/* We're going to sleep, so transition appropriately */
-		/* For now, only do this if we're a single STA vap */
-		if (sc->sc_nvaps == 1 &&
-		    vap->iv_opmode == IEEE80211_M_STA) {
-			DPRINTF(sc, ATH_DEBUG_BEACON,
-				"%s: syncbeacon=%d\n",
-				__func__, sc->sc_syncbeacon);
-			/*
-			 * Always at least set the self-generated
-			 * frame config to set PWRMGT=1.
-			 */
-			ath_power_setselfgen(sc, HAL_PM_NETWORK_SLEEP);
-
-			/*
-			 * If we're not syncing beacons, transition
-			 * to NETWORK_SLEEP.
-			 *
-			 * We stay awake if syncbeacon > 0 in case
-			 * we need to listen for some beacons otherwise
-			 * our beacon timer config may be wrong.
-			 */
-			if (sc->sc_syncbeacon == 0) {
-				ath_power_setpower(sc, HAL_PM_NETWORK_SLEEP);
-			}
-		}
 	}
 bad:
 	ieee80211_free_node(ni);
-
-	/*
-	 * Restore the power state - either to what it was, or
-	 * to network_sleep if it's alright.
-	 */
-	ath_power_restore_power_state(sc);
-
 	return error;
 }
 
@@ -6086,16 +5683,7 @@ ath_newassoc(struct ieee80211_node *ni, int isnew)
 	an->an_mcastrix = ath_tx_findrix(sc, tp->mcastrate);
 	an->an_mgmtrix = ath_tx_findrix(sc, tp->mgmtrate);
 
-	DPRINTF(sc, ATH_DEBUG_NODE,
-		"%s: %s: reassoc; isnew=%d, is_powersave=%d\n",
-		__func__,
-		ath_hal_ether_sprintf(ni->ni_macaddr),
-		isnew,
-		an->an_is_powersave);
-
-	ATH_NODE_LOCK(an);
 	ath_rate_newassoc(sc, an, isnew);
-	ATH_NODE_UNLOCK(an);
 
 	if (isnew &&
 	    (vap->iv_flags & IEEE80211_F_PRIVACY) == 0 && sc->sc_hasclrkey &&
@@ -6339,8 +5927,6 @@ ath_watchdog(void *arg)
 		struct ifnet *ifp = sc->sc_ifp;
 		uint32_t hangs;
 
-		ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 		if (ath_hal_gethangstate(sc->sc_ah, 0xffff, &hangs) &&
 		    hangs != 0) {
 			if_printf(ifp, "%s hang detected (0x%x)\n",
@@ -6350,7 +5936,6 @@ ath_watchdog(void *arg)
 		do_reset = 1;
 		ifp->if_oerrors++;
 		sc->sc_stats.ast_watchdog++;
-		ath_power_restore_power_state(sc);
 	}
 
 	/*
@@ -6475,10 +6060,6 @@ ath_ioctl_diag(struct ath_softc *sc, struct ath_diag *ad)
 			goto bad;
 		}
 	}
-
-	if (id != HAL_DIAG_REGS)
-		ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	if (ath_hal_getdiagstate(ah, id, indata, insize, &outdata, &outsize)) {
 		if (outsize < ad->ad_out_size)
 			ad->ad_out_size = outsize;
@@ -6488,8 +6069,6 @@ ath_ioctl_diag(struct ath_softc *sc, struct ath_diag *ad)
 	} else {
 		error = EINVAL;
 	}
-	if (id != HAL_DIAG_REGS)
-		ath_power_restore_power_state(sc);
 bad:
 	if ((ad->ad_id & ATH_DIAG_IN) && indata != NULL)
 		kfree(indata, M_TEMP);
@@ -6535,8 +6114,11 @@ ath_ioctl(struct ifnet *ifp, u_long cmd, caddr_t data,
 				ath_init(sc);	/* XXX lose error */
 		} else {
 			ath_stop_locked(ifp);
+#ifdef notyet
+			/* XXX must wakeup in places like ath_vap_delete */
 			if (!sc->sc_invalid)
-				ath_power_setpower(sc, HAL_PM_FULL_SLEEP);
+				ath_hal_setpower(sc->sc_ah, HAL_PM_FULL_SLEEP);
+#endif
 		}
 		ATH_UNLOCK(sc);
 		break;
